#version 400

layout(location = 0) in vec3 vertex_position;
layout(location = 1) in vec3 vertex_normal;
layout(location = 2) in vec2 in_texture_coordinates;

out vec2 texture_coordinates;
out vec3 fragPos;
out vec3 position_eye, normal_eye;
out flat int viewIndex;
uniform mat4 proj, view, model;
uniform sampler2D basic_texture[8];
uniform vec3 light_pos[10];
uniform float facingDir;

uniform vec3 playerPos;
uniform vec3 position;

void main () {
	float PI = 3.14159265358979323846264;
	float rot = PI;
	mat4 billMat =  view * model;
	billMat[0][0] = cos(rot); billMat[1][0] = 0.0; billMat[2][0] = sin(rot);
	billMat[0][1] = 0.0; billMat[1][1] = -1.0; billMat[2][1] = 0.0;
	billMat[0][2] = -sin(rot); billMat[1][2] = 0.0; billMat[2][2] = cos(rot);
	
	texture_coordinates = in_texture_coordinates;
	position_eye = vec3 (view  * vec4 (vertex_position, 1.0));
	normal_eye = vec3 (view  * vec4 (vertex_normal, 0.0));
	gl_Position = proj * billMat * vec4 (vertex_position, 1.0);
	fragPos =  (model * vec4 (vertex_position, 1.0)).xyz;
	
	float pi = 3.1415;
	float slice = pi / 4.0;
	float start = pi / 8.0;
	float angle = atan(position.z - playerPos.z, position.x - playerPos.x);

	float newDir = facingDir;
	
	while(angle < 0)
	{
		angle += pi * 2;
	}
	
	while(newDir < 0)
	{
		newDir += pi * 2;
	}
	
	angle += newDir;
	
	while(angle > pi * 2)
	{
		angle -= pi * 2;
	}
	
	
	if(angle >= pi / 8.0 && angle < (slice * 2) - start)
	{
		viewIndex = 7;
	}
	else if(angle >= (slice * 2) - start && angle < (slice * 3) - start )
	{
		viewIndex = 6;
	}
	else if(angle >= (slice * 3) - start && angle < (slice * 4) - start )
	{
		viewIndex = 5;
	}
	else if(angle >= (slice * 4) - start && angle < (slice * 5) - start )
	{
		viewIndex = 4;
	}
	else if(angle >= (slice * 5) - start && angle < (slice * 6) - start )
	{
		viewIndex = 3;
	}
	else if(angle >= (slice * 6) - start && angle < (slice * 7) - start )
	{
		viewIndex = 2;
	}
	else if(angle >= (slice * 7) - start && angle < (slice * 8) - start )
	{
		viewIndex = 1;
	}
	else
	{
		viewIndex = 0;
	}
	
}